@Echo off
SetLocal EnableDelayedExpansion

Echo ===== Tree Generator No.%__Alisha_Draft_Current% =====
Echo :: Count 4-char pads to the left of the data
Echo :: If the current pad count is greater than the previous pad count,
Echo :: add an ^<li style="list-style:none;"^>^<ul^> on a new line then add the line
Echo :: surrounded in ^<li^> tags.
Echo :: If the current pad count is less than the previous pad count,
Echo :: for /L %%%%T in (%%__Alisha_previous%%,-1,%%__Alisha_current%%) do Echo ^</ul^>^</li^>
Echo ::          -- Sintrode
Echo ================================

Pause

If "!__Alisha_tree_output!"=="" ( Exit /B )

Set "__Alisha_path=!__Alisha_Project_Path_[Root]!!__Alisha_Project_Path_[Project]! (!__Alisha_Project_Path_[Version]!)\"

Set /A "__Alisha_previous_depth=1"
Set /A "__Alisha_current_depth=1"

Set /A "__Alisha_current_toggle=1"
Call :__Zoey_Toggle

>> "!__Alisha_tree_output!" Echo ^<ul^> 

Set /A "__Alisha_Object_Count=0"

For /F "Skip=3 Delims=" %%T In ('Tree "!__Alisha_Project_Path_[Root]!!__Alisha_Project_Path_[Project]! (!__Alisha_Project_Path_[Version]!)\" /F /A') Do (
	
	Set "__Alisha_line=%%~T"
	
	Set /A "__Alisha_Object_Count+=1"
	
	Call :__Zoey_Toggle
	Call :__Zoey_Line_Entry

	Set __Alisha_path[!__Alisha_current_depth!]=!__Alisha_line!

	If !__Alisha_current_depth! GTR !__Alisha_previous_depth! (
		>> "!__Alisha_tree_output!" Echo ^<li style="list-style:none;"^>^<ul^>
	)
	If !__Alisha_current_depth! LSS !__Alisha_previous_depth! (
		Set __Alisha_path[!__Alisha_previous_depth!]=
		Set /A "__Alisha_depth_diff=!__Alisha_previous_depth!-!__Alisha_current_depth!"
		If !__Alisha_depth_diff! GTR 1 (
			For /L %%B In (1,1,!__Alisha_depth_diff!) Do (
				>> "!__Alisha_tree_output!" Echo ^</ul^>^</li^>
			)
		) Else (
			>> "!__Alisha_tree_output!" Echo ^</ul^>^</li^>
		)
	)
	If Not "!__Alisha_line!"=="" (
	
		Call :__Zoey_Toggle
		
		Rem :: Set "__Alisha_path=!__Alisha_Project_Path_[Root]!!__Alisha_Project_Path_[Project]! (!__Alisha_Project_Path_[Version]!)\"

		Set "__Alisha_path=."
		
		Set /A "__Alisha_pathmx=!__Alisha_current_depth!"
		Set /A "__Alisha_pathmx-=1"
		
		For /L %%C In (1,1,!__Alisha_pathmx!) Do (
			Set __Alisha_path=!__Alisha_path!\!__Alisha_path[%%C]!
		)
				
		Set __Alisha_linefile=!__Alisha_line!
		
		Set "__Alisha_line="
				
		Call :__Zoey_Previews !__Alisha_linefile!
		
		Echo Object No.!__Alisha_Object_Count!: !__Alisha_line!

		Echo.
		
		>> "!__Alisha_tree_output!" Echo ^<li class=^"!__Alisha_evenodd!"^>!__Alisha_line!^</li^>
	
	)
	
	Set "__Alisha_previous_depth=!__Alisha_current_depth!"
)

For /L %%T in (2,1,!__Alisha_current_depth!) Do (
	>> "!__Alisha_tree_output!" Echo ^</ul^>^</li^>
)
(
    Echo ^</ul^>
) >> "!__Alisha_tree_output!"

Exit /B 0

:__Zoey_Line_Entry

	Set "__Alisha_line=!__Alisha_line:|   =\t!"
	Set "__Alisha_line=!__Alisha_line:    =\t!"
	Set "__Alisha_line=!__Alisha_line:+---=\t!"
	Set "__Alisha_line=!__Alisha_line:\---=\t!"
	
	Set "__Alisha_current_depth=0"
	Set "__Alisha_line_Temp=!__Alisha_line!"
		
:__Zoey_line_Loop
		
	If "%__Alisha_line_Temp:~0,2%"=="\t" (
						
		Set /A "__Alisha_current_depth+=1"
		Set "__Alisha_line_Temp=!__Alisha_line_Temp:~2!"
		Goto :__Zoey_line_Loop
	)
			
	Set "__Alisha_line=!__Alisha_line_Temp!"
	
	Exit /B
	
:__Zoey_Toggle	
	
	Set /A "__Alisha_previous_toggle=!__Alisha_current_toggle!"
	Set /A "__Alisha_current_toggle=1-!__Alisha_previous_toggle!"
	
	If !__Alisha_current_toggle! EQU 1 (
		Set __Alisha_evenodd=odd
	) Else If !__Alisha_current_toggle! EQU 0 (
		Set __Alisha_evenodd=even
	)
	
	Exit /B

:__Zoey_Preview_Seq
	
	Echo :__Zoey_Preview_Seq
	Echo Valid extension from SEQ found.

	Rem Rem :: Pause

	If !__Alisha_Modes_Counter! GTR 0 (
		Exit /B
	) Else (
		Set /A "__Alisha_Modes_Counter+=1"
	)

	Call :__Zoey_Previews_Attributes

	Set __Alisha_line=!__Alisha_line! ^<a class=^"purple^" href=^"!__Alisha_path!\!__Alisha_linefile!^"^>!__Alisha_linefile!^</a^>
	
	Set __Alisha_line=!__Alisha_line! Last Modified: !__Alisha_Attribute_Time!
	
	Set __Alisha_line=!__Alisha_line! ^( !__Alisha_Attribute_Size! Bytes ^)
	
	Rem :: Cycle thru first 5 lines
		
	For /L %%L In ( 0, 1, 4 ) Do (
		Set "__Alisha_line[%%L]="
	)
					
	(
		Set /P "__Alisha_line[0]="
		Set /P "__Alisha_line[1]="
		Set /P "__Alisha_line[2]="
		Set /P "__Alisha_line[3]="
		Set /P "__Alisha_line[4]="
	) < "!__Alisha_path!\!__Alisha_linefile!"
	
	For /L %%L In ( 0, 1, 4 ) Do (
		Call :__Zoey_Line_Crop_Entry %%L
		Set __Alisha_line=!__Alisha_line!^<pre style=^"font-size: 0.5em;^"^>Line No.%%L:^&nbsp;^&nbsp;!__Alisha_line[%%L]!^</pre^>
	)
	
	Exit /B
	
:__Zoey_Preview_Images

	Echo :__Zoey_Preview_Images
	Echo Valid image extension found.

	Rem Rem :: Pause

	If !__Alisha_Modes_Counter! GTR 0 (
		Exit /B
	) Else (
		Set /A "__Alisha_Modes_Counter+=1"
	)

	Call :__Zoey_Previews_Attributes

	Rem :: Insert image into preview

	Set __Alisha_line=^<a class=^"purple^" href=^"!__Alisha_path!\!__Alisha_linefile!^"^>^<img src=^"!__Alisha_path!\!__Alisha_linefile!^" alt=^"!__Alisha_linefile!^" style=^"width: 16px; height: 16px;^"^>^</a^>^&nbsp;^&nbsp;!__Alisha_line!
	
	Set __Alisha_line=!__Alisha_line! ^<a class=^"purple^" href=^"!__Alisha_path!\!__Alisha_linefile!^"^>!__Alisha_linefile!^</a^>
	
	Set __Alisha_line=!__Alisha_line! Last Modified: !__Alisha_Attribute_Time!"
	
	Set "__Alisha_line=!__Alisha_line! ^( !__Alisha_Attribute_Size! Bytes ^)
	
	Exit /B

:__Zoey_Preview_Default

	Echo :__Zoey_Preview_Default
	Echo Invalid extension found.
	
	Rem Rem :: Pause

	If !__Alisha_Modes_Counter! GTR 0 (
		Exit /B
	) Else (
		Set /A "__Alisha_Modes_Counter+=1"
	)

	Set __Alisha_line=!__Alisha_line! ^<a class=^"purple^" href=^"!__Alisha_path!\!__Alisha_linefile!^"^>!__Alisha_linefile!^</a^>

	Exit /B
	
:__Zoey_Previews

	Echo :__Zoey_Previews
	Echo --^> "!__Alisha_path!\!__Alisha_linefile!" ^<--
	
	Rem Rem :: Pause
	
	If Not Exist "!__Alisha_path!\!__Alisha_linefile!" (
		Exit /B
	)
	
	Set /A "__Alisha_Modes_Counter=0"
	Set "__Alisha_Preview_Mode=Default"

	Set "__Alisha_line="
	
	Echo DEBUG:
	Echo Argument: "%*"
	Echo Formats: "!__Alisha_Modes_Formats!"
	Echo Counter: "!__Alisha_Modes_Counter!"

	Set "__Alisha_Attribute_Time="
	Set "__Alisha_Attribute_Size="
	Set "__Alisha_Attribute_Name="

	Rem Rem :: Pause
	
	For %%F In ( !__Alisha_Modes_Formats! ) Do (
		
		Echo Mode: "%%F"
		Echo Extensions: "!__Alisha_Modes_Extensions[%%F]!"
		Echo Extension: "%~x1"
		
		Rem Rem :: Pause

		If Not "%~x1"=="" (
			Set "__Alisha_Detected_Extension=%~x1"
			Echo File Extension "!__Alisha_Detected_Extension!" Detected.
			Rem Rem :: Pause
			
			Echo __Alisha_Modes_Extensions[%%F]
			
			Echo Was: "!__Alisha_Modes_Extensions[%%F]!"
			
			Set "__Alisha_To_Case_[Map]=L"
			Call :__Zoey_To_Case !__Alisha_Modes_Extensions[%%F]!
			Set "__Alisha_Modes_Extensions[%%F]=!__Alisha_To_Case_[Buffer]!"

			Echo Now: "!__Alisha_Modes_Extensions[%%F]!"

			Echo __Alisha_Detected_Extension

			Echo Was: !__Alisha_Detected_Extension!
			
			Set "__Alisha_To_Case_[Map]=L"
			Call :__Zoey_To_Case !__Alisha_Detected_Extension!
			Set "!__Alisha_Detected_Extension!=!__Alisha_To_Case_[Buffer]!"
			
			Echo Now: "!__Alisha_Detected_Extension!"
			
			Pause
			
			If Not "!__Alisha_Modes_Extensions[%%F]!"=="!__Alisha_Modes_Extensions[%%F]:__Alisha_Detected_Extension=!" (
				
				Echo Found Preview Mode "%%F".
				Rem Rem :: Pause
				
				If "%%F"=="Images" (
					
					Set "__Alisha_Preview_Mode=%%F"
					Echo Preview mode "%%F" Detected.
					Call :__Zoey_Previews_Attributes
					Rem Rem :: Pause
					
				) Else If "%%F"=="Seq" (
				
					Set "__Alisha_Preview_Mode=%%F"
					Echo Preview mode "%%F" Detected.
					Rem Rem :: Pause
					Call :__Zoey_Previews_Attributes
					
				)
			)
		) Else (
			Echo Missing File Extension.
			Rem Rem :: Pause
		)
	)
	
	Echo :__Zoey_Preview_!__Alisha_Preview_Mode!
	
	Rem Rem :: Pause
	
	Call :__Zoey_Preview_!__Alisha_Preview_Mode!
		
	Rem Rem :: Pause	
	
	Exit /B

:__Zoey_Previews_Attributes

	Echo :__Zoey_Previews_Attributes
	
	Set "__Alisha_Attribute_Time="
	Set "__Alisha_Attribute_Size="
	Set "__Alisha_Attribute_Name="
	
	Echo "!__Alisha_path!\!__Alisha_linefile!"
	Rem Rem :: Pause
	
	If Exist "!__Alisha_path!\!__Alisha_linefile!" (
		
		For %%A in ("!__Alisha_path!\!__Alisha_linefile!") Do (
		
			Echo A is set as "%%~A"
			Echo Path is set as "%cd%"
			Rem Rem :: Pause 

			For /F "Tokens=1-2,3,*" %%B in ('Dir "%%~A" /tw /4 ^| Find "%%~nxA"') Do (
				
				Echo "%%~A" "%%B" "%%C" "%%D" "%%E"
				Rem Rem :: Pause
				
				Set "__Alisha_Attribute_Time=%%B %%C"
				Set "__Alisha_Attribute_Size=%%D"
				Set "__Alisha_Attribute_Name=%%E"
			)
		)
	 
		Echo File: "!__Alisha_path!\!__Alisha_linefile!"
		Echo __Alisha_Attribute_Time is set as "!__Alisha_Attribute_Time!"
		Echo __Alisha_Attribute_Size is set as "!__Alisha_Attribute_Size!"
		Echo __Alisha_Attribute_Name is set as "!__Alisha_Attribute_Name!"

		Rem Rem :: Pause
	)
	
:__Zoey_Line_Crop_Entry
	
	Set "__Alisha_Line_Crop_Index=%*"

:__Zoey_Line_Crop_Loop



	If "!__Alisha_line[%__Alisha_Line_Crop_Index%]:~0,1!"==" " (
		Set __Alisha_line[%__Alisha_Line_Crop_Index%]=!__Alisha_line[%__Alisha_Line_Crop_Index%]:~1!
		Goto :__Zoey_Line_Crop_Loop
	)

	If "!__Alisha_line[%__Alisha_Line_Crop_Index%]:~-1!"==" " (
		Set __Alisha_line[%__Alisha_Line_Crop_Index%]=!__Alisha_line[%__Alisha_Line_Crop_Index%]:~0,-1!
		Goto :__Zoey_Line_Crop_Loop
	)

	If "!__Alisha_line[%__Alisha_Line_Crop_Index%]:~0,1!"=="	" (
		Set __Alisha_line[%__Alisha_Line_Crop_Index%]=!__Alisha_line[%__Alisha_Line_Crop_Index%]:~1!
		Goto :__Zoey_Line_Crop_Loop
	)

	If "!__Alisha_line[%__Alisha_Line_Crop_Index%]:~-1!"=="	" (
		Set __Alisha_line[%__Alisha_Line_Crop_Index%]=!__Alisha_line[%__Alisha_Line_Crop_Index%]:~0,-1!
		Goto :__Zoey_Line_Crop_Loop
	)
	
	Exit /B

:__Zoey_To_Case
	
	Set "__Alisha_To_Case_[Buffer_In]=%*"
	Set "!__Alisha_To_Case_[Map]!=L"

	Call :__Zoey_To_Case_Loop
	
	Set "__Alisha_To_Case_[Buffer]=!__Alisha_To_Case_[Buffer_Out]!"
	Exit /B
	
:__Zoey_To_Case_Loop
	 
	Set "__Alisha_To_Case_[Buffer_In]=!__Alisha_To_Case_[Buffer]!"
	 Goto:__Zoey_To_Case_Loop_2

:__Zoey_To_Case_Loop_2

	If "!__Alisha_To_Case_[Buffer_In]!"=="" (
		Exit /B
	)
	
	Set "__Alisha_To_Case_[Char]=!__Alisha_To_Case_[Buffer_In]:0,1!"
	
	Set "__Alisha_To_Case_[Buffer]=!__Alisha_To_Case_[Buffer_In]:1!"
	
	For %%A In ("a=A" "b=B" "c=C" "d=D" "e=E" "f=F" "g=G" "h=H" "i=I"
        "j=J" "k=K" "l=L" "m=M" "n=N" "o=O" "p=P" "q=Q" "r=R"
        "s=S" "t=T" "u=U" "v=V" "w=W" "x=X" "y=Y" "z=Z" "ä=Ä"
        "ö=Ö" "ü=Ü") Do (
		
		If "!__Alisha_To_Case_[Map]!==L" (
			Set "__Alisha_To_Case_[Char_In]=%%A:2,1"
			Set "__Alisha_To_Case_[Char_Out]=%%A:0,1"
		) Else If "!__Alisha_To_Case_[Map]!==U" (
			Set "__Alisha_To_Case_[Char_In]=%%A:0,1"
			Set "__Alisha_To_Case_[Char_Out]=%%A:2,1"
		)
		
		If "!__Alisha_To_Case_[Char]!"=="!__Alisha_To_Case_[Char_In]!"
		(
			Set "__Alisha_To_Case_[Char]=!__Alisha_To_Case_[Char_Out]!"
		)
		
		Set "__Alisha_To_Case_[Buffer_Out]=!__Alisha_To_Case_[Buffer_Out]!!__Alisha_To_Case_[Char]!"
	)

	Goto :__Zoey_To_Case_Loop_2
	